/*
 * CAbout.cpp
 *
 *  Created on: 12.05.2010
 *      Author: vdv
 */

#include "CAbout.h"
#include "CTerminal.h"
#include "CImage.h"
#include "CButton.h"
#include "CFont.h"
#include "about.xbm"
#include "CMainMenu.h"

#define TEXT_VERSION_X	50
#define TEXT_VERSION_Y	20

CAbout::CAbout()
{
	SetSize( CTerminal::GetScreenWidth(), CTerminal::GetScreenHeight() );
	SetLocation( 0, 0 );
	m_image = CImage::CreateXBMImage( about_bits, about_width, about_height );
	CButton* b = new CButton( L"OK" );
	b->SetSize( 16, 12 );
	b->SetLocation( m_x + m_width - 16, m_y + m_height - 12 );
	CFont* font = CFont::GetFont( FONT_FACE_MONOSPACE, FONT_STYLE_PLAIN, 8 );
	b->SetFont( font );
	b->SetCommandAction( this, &DispatchAction );
	Add( b );
	m_version = L"software version: 0.1";
}
CAbout::~CAbout()
{
	if( m_image != NULL ) delete m_image;
}

void CAbout::Paint(CGraphics* g)
{
	g->DrawImage( m_image, m_sx, m_sy, GRAPHICS_LEFT | GRAPHICS_TOP );
	g->DrawString( &m_version, m_sx + TEXT_VERSION_X, m_sy + TEXT_VERSION_Y, GRAPHICS_LEFT | GRAPHICS_TOP );
	CForm::Paint( g );
}

void CAbout::DispatchAction(void* about, CComponent* component)
{
	CAbout* m = (CAbout*)about;
	//if( component == m->m_ok )
	{
		CTerminal::AddForm( new CMainMenu() );
		m->OnClose();
	}
}
