/*
 * CGUI.cpp
 *
 *  Created on: 16.04.2010
 *      Author: vdv
 */

#include <stdlib.h>
#include <pthread.h>// pthread
#include <unistd.h>// usleep
#include <sys/time.h>// timeval, gettimeofday

#include "integer.h"
#include "CGUI.h"
#include "CTerminal.h"
// include gui classes
#include "CMainScreen.h"
#include "CMainMenu.h"
#include "CMenuIPSettings.h"
#include "CAbout.h"

#define REFRESH_PERIOD_MKS			200000//mks, 5fps
#define DISPLAY_BLANK_INTERVAL_S	120// sec

static BOOL bWork = TRUE;

void prepare()
{
	CTerminal::AddForm( new CMainScreen() );
}

static timeval blank_time;
void SetTimer(time_t seconds)
{
	timeval t;
	t.tv_sec = seconds;
	t.tv_usec = 0;
	::gettimeofday( &blank_time, NULL );
	timeradd( &blank_time, &t, &blank_time );
}

BOOL IsTimerOut()
{
	timeval t;
	::gettimeofday( &t, NULL );
	return timercmp( &t, &blank_time, > );
}

void* gui_thread(void* arg)
{
	::pthread_detach( ::pthread_self() );
	// init
	if( CTerminal::Init() != TRUE )
	{//error, stop
		::pthread_exit( NULL );
		return NULL;
	}
	// prepare first form
	prepare();
	CTerminal::UnBlankDisplay();
	SetTimer( (time_t)DISPLAY_BLANK_INTERVAL_S );
	// working loop
	while( bWork )
	{
		while( CTerminal::NextAction() )
		{
			CTerminal::UnBlankDisplay();
			SetTimer( (time_t)DISPLAY_BLANK_INTERVAL_S );
			CTerminal::ProcessUserActions();
		}
		//
		CTerminal::OnTimer();
		//
		CTerminal::Paint();// and flush to device, if need
		//
		if( IsTimerOut() )
		{
			CTerminal::BlankDisplay();
		}
		//
		::usleep( REFRESH_PERIOD_MKS );
	}
	::pthread_exit( NULL );
	return NULL;
}
