/*
 * CMainMenu.cpp
 *
 *  Created on: 12.05.2010
 *      Author: vdv
 */

#include "CMainMenu.h"
#include "CTerminal.h"
#include "CPanel.h"
#include "CButton.h"
#include "CFont.h"
#include "CMainScreen.h"
#include "CMenuIPSettings.h"
#include "CMenuGatewayDNSSettings.h"
#include "CAbout.h"

#define SHIFT_X		10
#define BUTTON_WIDTH		(192 - SHIFT_X * 2)
#define BUTTON_HEIGHT		8

CMainMenu::CMainMenu()
    : CWindow( L"MAIN MENU" )
{
	SetSize( CTerminal::GetScreenWidth(), CTerminal::GetScreenHeight() );
	SetLocation( 0, 0 );
	CFont* font = CFont::GetFont( FONT_FACE_MONOSPACE, FONT_STYLE_PLAIN, BUTTON_HEIGHT );
	CPanel* p = new CPanel();
	p->SetLocation( 0, 0 );
	p->SetSize( m_content_width, m_content_height );
	m_ip = new CButton( L"IP settings" );
	m_ip->SetSize( BUTTON_WIDTH, BUTTON_HEIGHT );
	m_ip->SetLocation( SHIFT_X, 0 );
	m_ip->SetFont( font );
	m_ip->SetCommandAction( this, &DispatchAction );
	p->Add( m_ip );
	m_gateway = new CButton( L"Gateway & DNS settings" );
	m_gateway->SetSize( BUTTON_WIDTH, BUTTON_HEIGHT );
	m_gateway->SetLocation( SHIFT_X, BUTTON_HEIGHT );
	m_gateway->SetFont( font );
	m_gateway->SetCommandAction( this, &DispatchAction );
	p->Add( m_gateway );
	m_about = new CButton( L"About" );
	m_about->SetSize( BUTTON_WIDTH, BUTTON_HEIGHT );
	m_about->SetLocation( SHIFT_X, BUTTON_HEIGHT * 2 );
	m_about->SetFont( font );
	m_about->SetCommandAction( this, &DispatchAction );
	p->Add( m_about );
	Add( p );
	Pack();
}
CMainMenu::~CMainMenu()
{
}

void CMainMenu::CloseAction()
{
	CTerminal::AddForm( new CMainScreen() );
}

void CMainMenu::DispatchAction(void* menu, CComponent* component)
{
	CMainMenu* m = (CMainMenu*)menu;
	if( component == m->m_ip )
	{
		CTerminal::AddForm( new CMenuIPSettings() );
		m->OnClose();
	} else if( component == m->m_gateway )
	{
		CTerminal::AddForm( new CMenuGatewayDNSSettings() );
		m->OnClose();
	} else if( component == m->m_about )
	{
		CTerminal::AddForm( new CAbout() );
		m->OnClose();
	}
}
