/*
 * CMainScreen.cpp
 *
 *  Created on: 12.05.2010
 *      Author: vdv
 */

#include <linux/input.h>// KEY_CODE

#include "integer.h"
#include "CMainScreen.h"
#include "CTerminal.h"
#include "CPanel.h"
#include "CLabel.h"
#include "CComboBox.h"
#include "CButton.h"
#include "CListBox.h"
#include "CFont.h"
#include "CMainMenu.h"
#include "CGraphics.h"

#define PANEL_WIDTH		44
#define ITEM_HEIGHT		8
#define TIME_STR_LEN	8

CMainScreen::CMainScreen()
{
	SetSize( CTerminal::GetScreenWidth(), CTerminal::GetScreenHeight() );
	SetLocation( 0, 0 );
	CFont* font = CFont::GetFont( FONT_FACE_MONOSPACE, FONT_STYLE_PLAIN, ITEM_HEIGHT );
	CPanel* p = new CPanel();
	p->SetLocation( m_x + m_width - PANEL_WIDTH, 0 );
	p->SetSize( PANEL_WIDTH, m_height );
	//
	time_t time = ::time( NULL );
	tm* t = ::localtime( &time );
	CHAR time_str[TIME_STR_LEN + 1];
	::swprintf( time_str, TIME_STR_LEN + 1, L"%02d:%02d:%02d", t->tm_hour, t->tm_min, t->tm_sec );
	//
	m_time = new CLabel( time_str );
	m_time->SetSize( PANEL_WIDTH, ITEM_HEIGHT );
	m_time->SetLocation( 0, 0 );
	m_time->SetFont( font );
	p->Add( m_time );
	//
	m_mode = new CComboBox();
	m_mode->SetSize( PANEL_WIDTH, ITEM_HEIGHT );
	m_mode->SetLocation( 0, ITEM_HEIGHT );
	m_mode->SetFont( font );
	m_mode->SetCommandAction( this, &DispatchAction );
	SItem* i = new SItem();
	i->key = L"1";
	i->text = L"mode 1";
	m_mode->AddItem( i );
	i = new SItem();
	i->key = L"1";
	i->text = L"mode 2";
	m_mode->AddItem( i );
	i = new SItem();
	i->key = L"3";
	i->text = L"mode 3";
	m_mode->AddItem( i );
	p->Add( m_mode );
	//
	m_channel = new CComboBox();
	m_channel->SetSize( PANEL_WIDTH, ITEM_HEIGHT );
	m_channel->SetLocation( 0, ITEM_HEIGHT * 2 );
	m_channel->SetFont( font );
	m_channel->SetCommandAction( this, &DispatchAction );
	i = new SItem();
	i->key = L"1";
	i->text = L"set 1";
	m_channel->AddItem( i );
	i = new SItem();
	i->key = L"2";
	i->text = L"set 2";
	m_channel->AddItem( i );
	p->Add( m_channel );
	//
	m_options = new CButton( L"OPTIONS" );
	m_options->SetSize( PANEL_WIDTH, ITEM_HEIGHT );
	m_options->SetLocation( 0, ITEM_HEIGHT * 3 );
	m_options->SetFont( font );
	m_options->SetCommandAction( this, &DispatchAction );
	p->Add( m_options );
	Add( p );
	// for testing
		CListBox* b = new CListBox();
		b->SetLocation( 7, 0 );
		b->SetSize( m_width - PANEL_WIDTH - 14, m_height );
		b->SetFont( font );
		CLabel* lb = new CLabel( L"1. line" );
		lb->SetSize( 100, 8 );
		lb->SetLocation( 0, 0 );
		b->Add( lb );
		lb = new CLabel( L"2. line" );
		lb->SetSize( 100, 8 );
		lb->SetLocation( 0, 8 );
		b->Add( lb );
		lb = new CLabel( L"3. line" );
		lb->SetSize( 100, 8 );
		lb->SetLocation( 0, 16 );
		b->Add( lb );
		lb = new CLabel( L"4. line" );
		lb->SetSize( 100, 8 );
		lb->SetLocation( 0, 24 );
		b->Add( lb );
		Add( b );
	//
	Pack();
	// create and init timer
	m_timer = ::time( NULL );
}
CMainScreen::~CMainScreen()
{
}

void CMainScreen::OnTimer()
{
	time_t t = ::time( NULL );
	if( t != m_timer )
	{
		m_timer = t;
		Repaint();
	}
}

void CMainScreen::Paint(CGraphics* g)
{
	SPoint p = GetScreenPosition();
	// one meter
	INT16 left = ::rand() % m_height;
	INT16 right = ::rand() % m_height;
	g->DrawRectangle( m_sx, m_sy, 6, m_height );
	g->FillRectangle( m_sx + 1, m_height - left, 2, left );
	g->FillRectangle( m_sx + 4, m_height - right, 2, right );
	// two meter
	left = ::rand() % m_height;
	right = ::rand() % m_height;
	g->DrawRectangle( m_sx + 141, m_sy, 6, m_height );
	g->FillRectangle( m_sx + 141 + 1, m_height - left, 2, left );
	g->FillRectangle( m_sx + 141 + 4, m_height - right, 2, right );
	// time
	time_t time = ::time( NULL );
	tm* t = ::localtime( &time );
	CHAR time_str[TIME_STR_LEN + 1];
	::swprintf( time_str, TIME_STR_LEN + 1, L"%02d:%02d:%02d", t->tm_hour, t->tm_min, t->tm_sec );
	m_time->SetText( time_str );

	CForm::Paint( g );
}

void CMainScreen::DispatchAction(void* mscreen, CComponent* component)
{
	CMainScreen* m = (CMainScreen*)mscreen;
	if( component == m->m_options )
	{
		CTerminal::AddForm( new CMainMenu() );
		m->OnClose();
	} else if( component == m->m_mode )
	{
	} else if( component == m->m_channel )
	{
	}
}
