/*
 * CMenuIPSettings.cpp
 *
 *  Created on: 12.05.2010
 *      Author: vdv
 */

#include "CMenuGatewayDNSSettings.h"
#include "CTerminal.h"
#include "CPanel.h"
#include "CLabel.h"
#include "CIPAddressBox.h"
#include "CGUIConstants.h"
#include "CFont.h"
#include "CMainMenu.h"

#define PIVOT_POINT_X	90
#define LINE_HEIGHT		8

CMenuGatewayDNSSettings::CMenuGatewayDNSSettings()
    : CWindow( L"GATEWAY & DNS SETTINGS" )
{
	SetSize( CTerminal::GetScreenWidth(), CTerminal::GetScreenHeight() );
	SetLocation( 0, 0 );
	CFont* font = CFont::GetFont( FONT_FACE_MONOSPACE, FONT_STYLE_PLAIN, LINE_HEIGHT );
	CPanel* p = new CPanel();
	p->SetLocation( 0, 0 );
	p->SetSize( m_content_width, m_content_height );
	//
	CLabel* lb = new CLabel( L"gateway: " );
	lb->SetAligment( LIBGUI_RIGHT | LIBGUI_TOP );
	lb->SetSize( 60, LINE_HEIGHT );
	lb->SetLocation( PIVOT_POINT_X - 60, 0 );
	lb->SetFont( font );
	p->Add( lb );
	lb = new CLabel( L"dns-0: " );
	lb->SetAligment( LIBGUI_RIGHT | LIBGUI_TOP );
	lb->SetSize( 60, LINE_HEIGHT );
	lb->SetLocation( PIVOT_POINT_X - 60, LINE_HEIGHT );
	lb->SetFont( font );
	p->Add( lb );
	lb = new CLabel( L"dns-1: " );
	lb->SetAligment( LIBGUI_RIGHT | LIBGUI_TOP );
	lb->SetSize( 60, LINE_HEIGHT );
	lb->SetLocation( PIVOT_POINT_X - 60, LINE_HEIGHT * 2 );
	lb->SetFont( font );
	p->Add( lb );
	//
	CIPAddressBox* ip = new CIPAddressBox( 192, 168, 0, 1 );
	ip->SetSize( PIVOT_POINT_X, LINE_HEIGHT );
	ip->SetLocation( PIVOT_POINT_X, 0 );
	ip->SetFont( font );
	p->Add( ip );
	ip = new CIPAddressBox( 192, 168, 0, 1 );
	ip->SetSize( PIVOT_POINT_X, LINE_HEIGHT );
	ip->SetLocation( PIVOT_POINT_X, LINE_HEIGHT );
	ip->SetFont( font );
	p->Add( ip );
	ip = new CIPAddressBox( 192, 168, 0, 1 );
	ip->SetSize( PIVOT_POINT_X, LINE_HEIGHT );
	ip->SetLocation( PIVOT_POINT_X, LINE_HEIGHT * 2 );
	ip->SetFont( font );
	p->Add( ip );
	Add( p );
	Pack();
}
CMenuGatewayDNSSettings::~CMenuGatewayDNSSettings()
{
}

void CMenuGatewayDNSSettings::CloseAction()
{
	CTerminal::AddForm( new CMainMenu() );
}
