/*
 * CMenuIPSettings.cpp
 *
 *  Created on: 12.05.2010
 *      Author: vdv
 */

#include "CMenuIPSettings.h"
#include "CTerminal.h"
#include "CPanel.h"
#include "CLabel.h"
#include "CTextBox.h"
#include "CIPAddressBox.h"
#include "CGUIConstants.h"
#include "CFont.h"
#include "CMainMenu.h"

#define PIVOT_POINT_X	90
#define LINE_HEIGHT		8

CMenuIPSettings::CMenuIPSettings()
    : CWindow( L"IP SETTINGS" )
{
	SetSize( CTerminal::GetScreenWidth(), CTerminal::GetScreenHeight() );
	SetLocation( 0, 0 );
	CFont* font = CFont::GetFont( FONT_FACE_MONOSPACE, FONT_STYLE_PLAIN, LINE_HEIGHT );
	CPanel* p = new CPanel();
	p->SetLocation( 0, 0 );
	p->SetSize( m_content_width, m_content_height );
	//
	CLabel* lb = new CLabel( L"name: " );
	lb->SetAligment( LIBGUI_RIGHT | LIBGUI_TOP );
	lb->SetSize( 30, LINE_HEIGHT );
	lb->SetLocation( PIVOT_POINT_X - 30, 0 );
	lb->SetFont( font );
	p->Add( lb );
	lb = new CLabel( L"ip: " );
	lb->SetAligment( LIBGUI_RIGHT | LIBGUI_TOP );
	lb->SetSize( 30, LINE_HEIGHT );
	lb->SetLocation( PIVOT_POINT_X - 30, LINE_HEIGHT );
	lb->SetFont( font );
	p->Add( lb );
	lb = new CLabel( L"mask: " );
	lb->SetAligment( LIBGUI_RIGHT | LIBGUI_TOP );
	lb->SetSize( 40, LINE_HEIGHT );
	lb->SetLocation( PIVOT_POINT_X - 40, LINE_HEIGHT * 2 );
	lb->SetFont( font );
	p->Add( lb );
	//
	CTextBox* t = new CTextBox( L"board.name" );
	t->SetSize( PIVOT_POINT_X, LINE_HEIGHT );
	t->SetLocation( PIVOT_POINT_X, 0 );
	t->SetFont( font );
	p->Add( t );
	CIPAddressBox* ip = new CIPAddressBox( 192, 168, 0, 1 );
	ip->SetSize( PIVOT_POINT_X, LINE_HEIGHT );
	ip->SetLocation( PIVOT_POINT_X, LINE_HEIGHT );
	ip->SetFont( font );
	p->Add( ip );
	ip = new CIPAddressBox( 255, 255, 255, 0 );
	ip->SetSize( PIVOT_POINT_X, LINE_HEIGHT );
	ip->SetLocation( PIVOT_POINT_X, LINE_HEIGHT * 2 );
	ip->SetFont( font );
	p->Add( ip );
	Add( p );
	Pack();
}
CMenuIPSettings::~CMenuIPSettings()
{
}

void CMenuIPSettings::CloseAction()
{
	CTerminal::AddForm( new CMainMenu() );
}
