/*********************************************
   Integer type definitions
**********************************************/

#ifndef INTEGER_H_
#define INTEGER_H_

#include <inttypes.h>
#include <string>

// String types
// if need wchar == 2 byte, use comliler's key -fshort-wchar
typedef wchar_t		CHAR;
//typedef wstring		CString;
typedef std::basic_string<CHAR, std::char_traits<CHAR>, std::allocator<CHAR> > CString;
#if WCHAR_MAX > 65535
	//UCS-2-INTERNAL, UCS-4-INTERNAL
# define INTERNAL_ENCODING "UCS-4-INTERNAL"
#else
# define INTERNAL_ENCODING "UCS-2-INTERNAL"
#endif
// These types must be 8-bit integer/
//typedef int8_t		SBYTE;
typedef int8_t		INT8;
//typedef uint8_t		BYTE;
typedef uint8_t		UINT8;

// These types must be 16-bit integer/
typedef int16_t		INT16;
typedef uint16_t	UINT16;

// These types must be 32-bit integer/
typedef int32_t		INT32;
typedef uint32_t	UINT32;

// These types must be 64-bit integer/
typedef int64_t		INT64;
typedef uint64_t	UINT64;

// Boolean type/
//typedef enum { FALSE = 0, TRUE } BOOL;
typedef	bool	BOOL;
#ifndef FALSE
    #define  FALSE   (0)
#endif
#ifndef TRUE
    #define  TRUE    (1)
#endif
#ifndef NULL
    #define  NULL    0
#endif

#endif

